Constructing Roads In JGShining's Kingdom(最长上升子序列)

Constructing Roads In JGShining‘s Kingdom

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 16956    Accepted Submission(s): 4819

Problem Description

JGShining‘s kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines.

Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we call them poor cities). Each poor city is short of exactly one kind of resource and also each rich city is rich in exactly one kind of resource.
You may assume no two poor cities are short of one same kind of resource and no two rich cities are rich in one same kind of resource.

With the development of industry, poor cities wanna import resource from rich ones. The roads existed are so small that they‘re unable to ensure the heavy trucks, so new roads should be built. The poor cities strongly BS each other, so are the rich ones. Poor
cities don‘t wanna build a road with other poor ones, and rich ones also can‘t abide sharing an end of road with other rich ones. Because of economic benefit, any rich city will be willing to export resource to any poor one.

Rich citis marked from 1 to n are located in Line I and poor ones marked from 1 to n are located in Line II.

The location of Rich City 1 is on the left of all other cities, Rich City 2 is on the left of all other cities excluding Rich City 1, Rich City 3 is on the right of Rich City 1 and Rich City 2 but on the left of all other cities ... And so as the poor ones.

But as you know, two crossed roads may cause a lot of traffic accident so JGShining has established a law to forbid constructing crossed roads.

For example, the roads in Figure I are forbidden.

In order to build as many roads as possible, the young and handsome king of the kingdom - JGShining needs your help, please help him. ^_^

Input

Each test case will begin with a line containing an integer n(1 ≤ n ≤ 500,000). Then n lines follow. Each line contains two integers p and r which represents that Poor City p needs to import resources from Rich City r. Process to
the end of file.

Output

For each test case, output the result in the form of sample.

You should tell JGShining what‘s the maximal number of road(s) can be built.

Sample Input

2
1 2
2 1
3
1 2
2 3
3 1

Sample Output

Case 1:
My king, at most 1 road can be built.

Case 2:
My king, at most 2 roads can be built.

Hint

Huge input, scanf is recommended.

题意:
           题目给出2n个城市,分别分布在道路两旁,一边为富裕的城市,另一边为贫穷的城市,经过时代的发展,现在要在富裕与贫穷的城市之间建立道路相连,
问满足条件的最多道路数. (条件: 道路两两不相交,且是符合一一对应的条件);

题解:
          简单DP,就是一个最长上升子序列的题目,不过题目很坑,在最后输出那里还要考虑道路的条数是否大于1,要是大于1,则需要输出roads.
被这个坑了好久,要以此为鉴,以后看题目要仔细认真,看清楚,理解清楚题目后在动手打码.

AC代码:
#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <queue>
#include <map>
#include <vector>
#include <cmath>
#include <cctype>

using namespace std;
typedef long long ll;
const int M = 5e5 + 100;
const int INF = 0xffffff;
int d[M];
char s[] = "s ";

struct Node
{
    int x,y;
    bool operator < (const Node &a) const
    {
        return a.y > y;
    }
    void readin()
    {
        scanf("%d %d",&x,&y);
    }
}p[M];

int main()
{
    freopen("in","r",stdin);
    int n,cnt = 0;
    while(~scanf("%d",&n))
    {
        int to = 0;
        for(int i = 0; i < n; i++)
            p[i].readin();
        sort(p,p + n);
        for(int i = 0; i < n; i++)
        {
            int u = lower_bound(d,d + to,p[i].x) - d;
            if(u == to) d[to++] = p[i].x;
            else d[u] = p[i].x;
        }
        printf("Case %d:\n",++cnt);
        printf("My king, at most %d road%scan be built.\n\n",to,to > 1 ? s : " ");
    }
    return 0;
}

Constructing Roads In JGShining's Kingdom(最长上升子序列)

时间: 2024-10-15 18:06:10

Constructing Roads In JGShining's Kingdom(最长上升子序列)的相关文章

hdu 1025 Constructing Roads In JGShining&#39;s Kingdom(二分法+最长上升子序列)

题目大意:河的两岸有两个不同的国家,一边是穷国,一边是富国,穷国和富国的村庄的标号是固定的,穷国要变富需要和富国进行交流,需要建桥,并且建的桥不能够有交叉.问最多可以建多少座桥.      思路:建路时如下图所示                 当一边的点已经固定了的时候,另外一边按照从小到大的序列与当前的边连接,得到最少的交叉.           题目给的第二组测试数据,如果按照图一则可以建2座桥,图二建一座桥 3 1 2 2 3 3 1                           

HDU-1025 Constructing Roads In JGShining&#39;s Kingdom O(nlogn)的最长上升子序列

模板题,唯一问题是当长度为1是,road是单数,不然road是复数roads. #include <iostream> #include <cstdio> #include <cmath> #include <cstring> #include <queue> #include <vector> #include <cstdlib> #include <algorithm> using namespace st

hdoj 1025 Constructing Roads In JGShining&#39;s Kingdom 【最长递增子序列】

Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 16262    Accepted Submission(s): 4633 Problem Description JGShining's kingdom consists of 2n(n is no mo

hdu 1025 Constructing Roads In JGShining&#39;s Kingdom(最长上升子序列nlogn算法)

学习了最长上升子序列,刚开始学的n^2的方法,然后就超时了,肯定超的,最大值都是500000,平方之后都12位 了,所以又开始学nlogn算法,找到了学长党姐的博客orz,看到了rating是浮云...确实啊,这些不必太关 注,作为一个动力就可以啦.没必要看的太重,重要的事学习知识. 思路: 这道题目可以先对一行排序,然后对另一行求最长上升子序列... n^2算法: 序列a[n],设一个数组d[n]表示到n位的时候最长公共子序列(此序列包括n),所以呢 d[n]=max(d[j]+1,0<j<

HDU 1025 Constructing Roads In JGShining&#39;s Kingdom[动态规划/nlogn求最长非递减子序列]

Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 27358    Accepted Submission(s): 7782 Problem Description JGShining's kingdom consists of 2n(n is no mor

Constructing Roads In JGShining&#39;s Kingdom HDU - 1025

JGShining's kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines. Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we call them poor cities)

hdu-1025 Constructing Roads In JGShining&#39;s Kingdom(二分查找)

题目链接: Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others)     Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 21045    Accepted Submission(s): 5950 Problem Description JGShining's kingdom consists of 2n(n is

LIS问题---HDU1025 Constructing Roads In JGShining&#39;s Kingdom

发现这个说的比较通俗: 假设存在一个序列d[1..9] = 2 1 5 3 6 4 8 9 7,可以看出来它的LIS长度为5.下面一步一步试着找出它.我们定义一个序列B,然后令 i = 1 to 9 逐个考察这个序列.此外,我们用一个变量Len来记录现在最长算到多少了首先,把d[1]有序地放到B里,令B[1] = 2,就是说当只有1一个数字2的时候,长度为1的LIS的最小末尾是2.这时Len=1然后,把d[2]有序地放到B里,令B[1] = 1,就是说长度为1的LIS的最小末尾是1,d[1]=2

hdu1025 Constructing Roads In JGShining&#39;s Kingdom

转载请注明出处:http://blog.csdn.net/u012860063 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1025 Problem Description JGShining's kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines. Half of these cities a